/*******************************************************************************
 *
 * FILENAME:     CalibrationMatrix.cpp
 * DESCRIPTION:  calibration matrix
 *
 * AUTHOR:       Jun Liu (jun@cs.man.ac.uk)
 * INSTITUTION:  Advanced Interfaces Group,
 *               Department of Computer Science,
 *               the University of Manchester, United Kingdom
 * DATE:         July 2006
 *
 *******************************************************************************/


#include "CalibrationMatrix.h"

vnl_double_3x3 CalibrationMatrix::generate(const double focalx,
                                           const double focaly,
                                           const double px,
                                           const double py,
                                           const double skew)
{
    vnl_double_3x3 rv;
    rv.fill(0.0);

    rv(0,0) = focalx;
    rv(0,1) = skew;
    rv(0,2) = px;
    rv(1,1) = focaly;
    rv(1,2) = py;
    rv(2,2) = 1.0;

    return rv;
}
