/*******************************************************************************
 *
 * FILENAME:     ProjectionMatrix.cpp
 * DESCRIPTION:  projection matrix
 *
 * AUTHOR:       Jun Liu (jun@cs.man.ac.uk)
 * INSTITUTION:  Advanced Interfaces Group,
 *               Department of Computer Science,
 *               the University of Manchester, United Kingdom
 * DATE:         July 2006
 *
 *******************************************************************************/




#include "ProjectionMatrix.h"


PMatrix ProjectionMatrix::generate(vnl_double_3x3 const& K,
                                  vnl_double_3x3 const& R,
                                  vnl_double_3   const& t)
{
    vnl_double_3x4 P;
    for (int i=0; i<3;++i)
        for (int j=0; j<3; ++j)
            P(i,j) = R(i,j);
    vnl_double_3 RT = R * t;

    for (int i=0; i<3;++i)
        P(i,3) = -RT(i);
    
    P = K * P;
    return PMatrix(P);
}

